SystemOrganization addCategory: #'BookBindingTJ-Core'!
SystemOrganization addCategory: #'BookBindingTJ-Test'!

Object subclass: #BookBindingTJ
	instanceVariableNames: 'tipoPapel cuadernillos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BookBindingTJ-Core'!

!BookBindingTJ class methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/27/2013 11:31'!
paginas: paginasLibro tipoPapel: tipoPapel
 ^ (self new)
 		paginas: paginasLibro tipoPapel: tipoPapel;yourself ! !

!BookBindingTJ methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/28/2013 16:41'!
calculoTamanioCuadernillo: paginasLibro
	| tamanioActual numeroHojas |
	self normalizarPaginasLibro: paginasLibro.
	tamanioActual  := tipoPapel numeroMaximoHoja.
	numeroHojas := paginasLibro size / 4.
	[ numeroHojas \\ tamanioActual = 0 ] whileFalse: [ tamanioActual := tamanioActual - 1 ].
	^ tamanioActual * 4! !

!BookBindingTJ methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/27/2013 17:38'!
cuadernillos 
	^ cuadernillos ! !

!BookBindingTJ methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/27/2013 11:11'!
initialize
	cuadernillos := OrderedCollection new! !

!BookBindingTJ methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/28/2013 17:14'!
normalizarPaginasLibro: paginasLibro
	[ (paginasLibro size \\ 4) = 0 ] whileFalse: [ paginasLibro addLast: PaginaLibroTJ paginaEnBlanco ]! !

!BookBindingTJ methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/28/2013 16:43'!
paginas: paginasLibro tipoPapel: pTipo
	| tamanioCuadernillo  inicio fin |
	tipoPapel  := pTipo.
	tamanioCuadernillo  := self calculoTamanioCuadernillo: paginasLibro.
	inicio := 1.
	fin := tamanioCuadernillo.
	paginasLibro  size / tamanioCuadernillo
		timesRepeat: [ 
			cuadernillos  addLast: (CuadernilloTJ conPaginas: (paginasLibro  copyFrom: inicio  to: fin)).
			inicio := fin + 1.
			fin := fin + tamanioCuadernillo ]! !

!BookBindingTJ methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/28/2013 15:25'!
paginasLibro 
	|resultado|
		resultado := SortedCollection 
			sortBlock: [ :first :second | first enBlanco not and: [ (second enBlanco not and: [first numeroPagina >
					second numeroPagina	]) not ]].
			cuadernillos do: [ :each | each coleccionPaginasLibro: resultado ].
			^ resultado ! !

Object subclass: #Cuadernillo
	instanceVariableNames: 'paginasLibro'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BookBindingTJ-Core'!

Object subclass: #CuadernilloTJ
	instanceVariableNames: 'paginasLibro'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BookBindingTJ-Core'!

!CuadernilloTJ class methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/27/2013 17:31'!
conPaginas: paginasLibro 
	^ (self new)
		calcularOrdenPagina: paginasLibro; yourself ! !

!CuadernilloTJ methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/27/2013 17:31'!
calcularOrdenPagina: paginas
	
	(paginas size / 2)
		timesRepeat: [
				paginasLibro addLast: paginas removeFirst.
				paginasLibro addLast: paginas removeLast 			
			]! !

!CuadernilloTJ methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/28/2013 14:58'!
coleccionPaginasLibro: aCollection
	aCollection addAll: paginasLibro ! !

!CuadernilloTJ methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/1/2013 11:32'!
imprimirNumerosPaginasOrdenados
    ^ paginasLibro collect: [ :each | each numeroPagina]! !

!CuadernilloTJ methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/27/2013 17:31'!
initialize 
	paginasLibro := OrderedCollection new! !

Object subclass: #PaginaLibro
	instanceVariableNames: 'numeroPagina enBlanco'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BookBindingTJ-Core'!

Object subclass: #PaginaLibroTJ
	instanceVariableNames: 'numeroPagina enBlanco'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BookBindingTJ-Core'!

!PaginaLibroTJ class methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/27/2013 17:32'!
numeroPagina: unNumero
	^ (self new)
		numeroPagina: unNumero;
		yourself ! !

!PaginaLibroTJ class methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/27/2013 17:32'!
paginaEnBlanco
	^ (self  new)
		setEnBlanco;yourself 	! !

!PaginaLibroTJ methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/27/2013 17:32'!
enBlanco 
	^ enBlanco ! !

!PaginaLibroTJ methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/27/2013 17:32'!
numeroPagina 
	^ numeroPagina ! !

!PaginaLibroTJ methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/1/2013 11:10'!
numeroPagina: unNumero
	numeroPagina := unNumero.
	enBlanco := false! !

!PaginaLibroTJ methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/27/2013 17:32'!
setEnBlanco
	enBlanco := true! !

Object subclass: #TipoPapelTJ
	instanceVariableNames: 'tamanioPapel numeroMaximoHoja'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BookBindingTJ-Core'!

!TipoPapelTJ class methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/27/2013 17:34'!
tamanio: cadena hojaMaxima: unNumero
	^ self new tamanio: cadena hojaMaxima: unNumero ! !

!TipoPapelTJ methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/27/2013 17:34'!
numeroMaximoHoja 
	^ numeroMaximoHoja ! !

!TipoPapelTJ methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/27/2013 17:34'!
tamanio: cadena hojaMaxima: unNumero
	tamanioPapel := cadena.
	numeroMaximoHoja := unNumero 
	! !

!TipoPapelTJ methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/27/2013 17:34'!
tamanioPapel 
	^ tamanioPapel ! !

TestCase subclass: #BookBindingTJSimpleTest
	instanceVariableNames: 'ochoPaginas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BookBindingTJ-Test'!

!BookBindingTJSimpleTest methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/28/2013 16:04'!
setUp
	| paginas |
	ochoPaginas := OrderedCollection new.
	1 to:8 do: [ :index | ochoPaginas add: (PaginaLibroTJ numeroPagina: index )].! !

!BookBindingTJSimpleTest methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/28/2013 16:09'!
tearDown 
	ochoPaginas := nil.! !

!BookBindingTJSimpleTest methodsFor: 'as yet unclassified' stamp: 'tomasJhon 6/28/2013 17:08'!
testOchoPaginas
	| binding |
	binding := BookBindingTJ paginas: ochoPaginas tipoPapel: (TipoPapelTJ tamanio: 'A4' hojaMaxima: 10).
	self should: [ binding paginasLibro size = 8].
	self should: [ binding paginasLibro detect: [ :each | each enBlanco ] ] raise: Error ! !

TestCase subclass: #CuadernilloTJTest
	instanceVariableNames: 'ochoPaginasCuadernillo cuatroPaginasCuadernillo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BookBindingTJ-Test'!

!CuadernilloTJTest methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/1/2013 11:50'!
setUp
	| paginas |
	cuatroPaginasCuadernillo :=  CuadernilloTJ 
		conPaginas: (OrderedCollection 
			with: ( PaginaLibroTJ numeroPagina: 1)
			with: ( PaginaLibroTJ numeroPagina: 2)
			with: ( PaginaLibroTJ numeroPagina: 3)
			with: ( PaginaLibroTJ numeroPagina: 4)).
			
		paginas := OrderedCollection  new.
		1 to:8 do: [ :index | paginas add: (PaginaLibroTJ numeroPagina: index )].
		ochoPaginasCuadernillo := CuadernilloTJ conPaginas: paginas ! !
